
#include <TinyGPS.h>

/* This sample code demonstrates the normal use of a TinyGPS object.
   It requires the use of SoftwareSerial, and assumes that you have a
   4800-baud serial GPS device hooked up on pins 3(rx) and 4(tx).
*/

TinyGPS gps;

static void gpsdump(TinyGPS &gps);
static bool feedgps();
static void print_float(float val, float invalid, int len, int prec);
static void print_int(unsigned long val, unsigned long invalid, int len);
static void print_date(TinyGPS &gps);
static void print_str(const char *str, int len);


#include <Wire.h>
  
  #define DEVICE (0x53)    //ADXL345 device address
  #define TO_READ (6)        //num of bytes we are going to read each time (two bytes for each axis)
  
 byte buff[TO_READ] ;    //6 bytes buffer for saving data read from the device
  char acc[512];
#include <gLCD.h>
const char RST = 8;
const char CS = 9;
const char Clk = 13;
const char Data = 11;
gLCD graphic(RST,CS,Clk,Data,HIGH_SPEED);
  char lcd_date[512];
  char lcd_time[512];
  char lcd_long[512];
  char lcd_lat[512];
  int  cpt_choc;
#define BACKGROUND  BLACK // room for growth, adjust the background color according to daylight
#define  FONT WHITE
  
  
  #include <SPI.h>
#include <SD.h>

File myFile;

void setup()
{
  Serial.begin(115200);
  Serial3.begin(4800);
  Wire.begin();        // join i2c bus (address optional for master)
   pinMode(10, OUTPUT);
   
  
  
   //Turning on the ADXL345
   writeTo(DEVICE, 0x2D, 0);      
   writeTo(DEVICE, 0x2D, 16);
   writeTo(DEVICE, 0x2D, 8);
   cpt_choc=0;
   graphic.begin(0,0,0,PHILLIPS_0); 
   graphic.setBackColour(15,15,15);
  graphic.setForeColour(0,0,0);
  graphic.setFont(Normal_SolidBG); 
  graphic.setCoordinate(5,0);
  graphic.print("TRACEUR DE CHOC");
  graphic.setCoordinate(5,10);
  graphic.print(" BY HOSSIE & KEMAJOU");
   
  Serial.print("Traceur de choc "); Serial.println(TinyGPS::library_version());
  Serial.println("by HOSSIE & KEMAJOU IMA4 SC 2012/2013");
  Serial.println();
  Serial.print("Sizeof(gpsobject) = "); Serial.println(sizeof(TinyGPS));
  Serial.println();
  Serial.println("Sats HDOP Latitude Longitude Fix  Date       Time       Date Alt     Course Speed Card  Distance Course Card  Chars Sentences Checksum acceleration");
  Serial.println("          (deg)    (deg)     Age                        Age  (m)     --- from GPS ----  ---- to PARIS   ----  RX    RX        Fail     x        y        z");
  Serial.println("----------------------------------------------------------------------------------------------------------------------------------------------------------");
 graphic.setCoordinate(5,30);
  graphic.print("DATE:");
   graphic.setCoordinate(5,40);
  graphic.print("TIME:");
    graphic.setCoordinate(5,50);
  graphic.print("LONGITUDE:");
   graphic.setCoordinate(5,60);
  graphic.print("LATITUDE:");
  graphic.setCoordinate(5,70);
  graphic.print("ACC");
   graphic.setCoordinate(5,80);
  graphic.print("NBCHOC");
   graphic.setCoordinate(5,90);
  if (!SD.begin(53)) {
    graphic.print("initialization failed!");
  }
    graphic.print("initialization done.");
    myFile = SD.open("logger.txt", FILE_WRITE);
    
    if (myFile) {
    myFile.println("TRACEUR DE CHOC");
	// close the file:
    myFile.close();
    
  } else {
    // if the file didn't open, print an error:
    graphic.println(" error opening file");
  }
}

void loop()
{
  bool newdata = false;
  unsigned long start = millis();
  
  // Every second we print an update
  while (millis() - start < 1000)
  {
    if (feedgps())
      newdata = true;
  }
  
  gpsdump(gps);
  int regAddress = 0x32;    //first axis-acceleration-data register on the ADXL345
    int x, y, z;
    
    readFrom(DEVICE, regAddress, TO_READ, buff); //read the acceleration data from the ADXL345
    
     //each axis reading comes in 10 bit resolution, ie 2 bytes.  Least Significat Byte first!!
     //thus we are converting both bytes in to one int
   x = (((int)buff[1]) << 8) | buff[0];   
   y = (((int)buff[3])<< 8) | buff[2];
   z = (((int)buff[5]) << 8) | buff[4];
   
  //we send the x y z values as a string to the serial port
  sprintf(acc, "%02d\t%02d\t%02d", x, y, z);  
   Serial.println(acc);
   
 
  graphic.setCoordinate(70,30);
  graphic.print(lcd_date);
 
  graphic.setCoordinate(70,40);
  graphic.print(lcd_time);

  graphic.setCoordinate(70,50);
  graphic.print(lcd_long);
 
  graphic.setCoordinate(70,60);
  graphic.print(lcd_lat);
  
  graphic.setCoordinate(60,70);
  graphic.print(acc); 
 graphic.setCoordinate(60,80);
  graphic.print(cpt_choc);  
  
  if ((abs(x)>300)||(abs(y)>300)||(abs(z)>300))
  {
     cpt_choc++;
    graphic.setCoordinate(40,100);
    graphic.print("######CHOC######");  
     delay(1000);
  graphic.setForeColour(15,15,15);
 graphic.print("                 ");
 graphic.setForeColour(0,0,0);
  
   myFile = SD.open("logger.txt", FILE_WRITE);
  if (myFile) {
   
   
    Serial.println("#################CHOC################");
    myFile.println("-------------------------------------");
    myFile.println("#################CHOC################");
    myFile.print("DATE:    ");
    myFile.println(lcd_date);
    myFile.print("TIME:    ");
    myFile.println(lcd_time);
    myFile.print("LONGITUDE:    ");
    myFile.println(lcd_long);
    myFile.print("LATITUDDE:    ");
    myFile.println(lcd_lat);  
    myFile.println("-------------------------------------");
    // read from the file until there's nothing else in it:
    
   
    // close the file:
    myFile.close();
  } else {
    graphic.setCoordinate(5,80);
    graphic.println("error opening test.txt");
  	// if the file didn't open, print an error:
    Serial.println("error opening test.txt");
  }
  
  }
}

static void gpsdump(TinyGPS &gps)
{
  float flat, flon;
  unsigned long age, date, time, chars = 0;
  unsigned short sentences = 0, failed = 0;
  static const float PARIS_LAT = 48.85661, PARIS_LON = 2.35222;
  
  print_int(gps.satellites(), TinyGPS::GPS_INVALID_SATELLITES, 5);
  print_int(gps.hdop(), TinyGPS::GPS_INVALID_HDOP, 5);
  gps.f_get_position(&flat, &flon, &age);
  print_float(flat, TinyGPS::GPS_INVALID_F_ANGLE, 9, 5);
  print_float(flon, TinyGPS::GPS_INVALID_F_ANGLE, 10, 5);
  print_int(age, TinyGPS::GPS_INVALID_AGE, 5);
  dtostrf(flon, 7, 6, lcd_long);
  dtostrf(flat, 7, 6, lcd_lat);
  //sprintf(lcd_long, "%d",flon*100000);
 // sprintf(lcd_lat, "%d",flat*100000);

  print_date(gps);

  print_float(gps.f_altitude(), TinyGPS::GPS_INVALID_F_ALTITUDE, 8, 2);
  print_float(gps.f_course(), TinyGPS::GPS_INVALID_F_ANGLE, 7, 2);
  print_float(gps.f_speed_kmph(), TinyGPS::GPS_INVALID_F_SPEED, 6, 2);
  print_str(gps.f_course() == TinyGPS::GPS_INVALID_F_ANGLE ? "*** " : TinyGPS::cardinal(gps.f_course()), 6);
  print_int(flat == TinyGPS::GPS_INVALID_F_ANGLE ? 0UL : (unsigned long)TinyGPS::distance_between(flat, flon, PARIS_LAT, PARIS_LON) / 1000, 0xFFFFFFFF, 9);
  print_float(flat == TinyGPS::GPS_INVALID_F_ANGLE ? 0.0 : TinyGPS::course_to(flat, flon, 51.508131, -0.128002), TinyGPS::GPS_INVALID_F_ANGLE, 7, 2);
  print_str(flat == TinyGPS::GPS_INVALID_F_ANGLE ? "*** " : TinyGPS::cardinal(TinyGPS::course_to(flat, flon, PARIS_LAT, PARIS_LON)), 6);

  gps.stats(&chars, &sentences, &failed);
  print_int(chars, 0xFFFFFFFF, 6);
  print_int(sentences, 0xFFFFFFFF, 10);
  print_int(failed, 0xFFFFFFFF, 9);
 // Serial.println();
}

static void print_int(unsigned long val, unsigned long invalid, int len)
{
  char sz[32];
  if (val == invalid)
    strcpy(sz, "*******");
  else
    sprintf(sz, "%ld", val);
  sz[len] = 0;
  for (int i=strlen(sz); i<len; ++i)
    sz[i] = ' ';
  if (len > 0) 
    sz[len-1] = ' ';
  Serial.print(sz);
  feedgps();
}

static void print_float(float val, float invalid, int len, int prec)
{
  char sz[32];
  if (val == invalid)
  {
    strcpy(sz, "*******");
    sz[len] = 0;
        if (len > 0) 
          sz[len-1] = ' ';
    for (int i=7; i<len; ++i)
        sz[i] = ' ';
    Serial.print(sz);
  }
  else
  {
    Serial.print(val, prec);
    int vi = abs((int)val);
    int flen = prec + (val < 0.0 ? 2 : 1);
    flen += vi >= 1000 ? 4 : vi >= 100 ? 3 : vi >= 10 ? 2 : 1;
    for (int i=flen; i<len; ++i)
      Serial.print(" ");
  }
  feedgps();
}

static void print_date(TinyGPS &gps)
{
  int year;
  byte month, day, hour, minute, second, hundredths;
  unsigned long age;
  gps.crack_datetime(&year, &month, &day, &hour, &minute, &second, &hundredths, &age);
  if (age == TinyGPS::GPS_INVALID_AGE)
    Serial.print("*******    *******    ");
  else
  {
    char sz[32];
    sprintf(sz, "%02d/%02d/%02d %02d:%02d:%02d   ",
        month, day, year, hour, minute, second);
        sprintf(lcd_time, "%02d:%02d:%02d",hour, minute, second);
        sprintf(lcd_date, "%02d/%02d/%02d",month, day, year, hour);
    Serial.print(sz);
  }
  print_int(age, TinyGPS::GPS_INVALID_AGE, 5);
  feedgps();
}

static void print_str(const char *str, int len)
{
  int slen = strlen(str);
  for (int i=0; i<len; ++i)
    Serial.print(i<slen ? str[i] : ' ');
  feedgps();
}

static bool feedgps()
{
  while (Serial3.available())
  {
    if (gps.encode(Serial3.read()))
      return true;
  }
  return false;
}
void writeTo(int device, byte address, byte val) {
    Wire.beginTransmission(device); //start transmission to device 
    Wire.write(address);        // send register address
    Wire.write(val);        // send value to write
    Wire.endTransmission(); //end transmission
 }
 void readFrom(int device, byte address, int num, byte buff[]) {
    Wire.beginTransmission(device); //start transmission to device 
    Wire.write(address);        //sends address to read from
    Wire.endTransmission(); //end transmission
    
    Wire.beginTransmission(device); //start transmission to device (initiate again)
    Wire.requestFrom(device, num);    // request 6 bytes from device
    
    int i = 0;
   while(Wire.available())    //device may send less than requested (abnormal)
   { 
   buff[i] = Wire.read(); // receive a byte
     i++;
   }
   Wire.endTransmission(); //end transmission
 }
